
package com.vmware.vim;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for HostNetworkConfig complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="HostNetworkConfig">
 *   &lt;complexContent>
 *     &lt;extension base="{urn:vim2}DynamicData">
 *       &lt;sequence>
 *         &lt;element name="vswitch" type="{urn:vim2}HostVirtualSwitchConfig" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="portgroup" type="{urn:vim2}HostPortGroupConfig" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="pnic" type="{urn:vim2}PhysicalNicConfig" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="vnic" type="{urn:vim2}HostVirtualNicConfig" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="consoleVnic" type="{urn:vim2}HostVirtualNicConfig" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="dnsConfig" type="{urn:vim2}HostDnsConfig" minOccurs="0"/>
 *         &lt;element name="ipRouteConfig" type="{urn:vim2}HostIpRouteConfig" minOccurs="0"/>
 *         &lt;element name="consoleIpRouteConfig" type="{urn:vim2}HostIpRouteConfig" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "HostNetworkConfig", propOrder = {
    "vswitch",
    "portgroup",
    "pnic",
    "vnic",
    "consoleVnic",
    "dnsConfig",
    "ipRouteConfig",
    "consoleIpRouteConfig"
})
public class HostNetworkConfig
    extends DynamicData
{

    protected List<HostVirtualSwitchConfig> vswitch;
    protected List<HostPortGroupConfig> portgroup;
    protected List<PhysicalNicConfig> pnic;
    protected List<HostVirtualNicConfig> vnic;
    protected List<HostVirtualNicConfig> consoleVnic;
    protected HostDnsConfig dnsConfig;
    protected HostIpRouteConfig ipRouteConfig;
    protected HostIpRouteConfig consoleIpRouteConfig;

    /**
     * Gets the value of the vswitch property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the vswitch property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getVswitch().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link HostVirtualSwitchConfig }
     * 
     * 
     */
    public List<HostVirtualSwitchConfig> getVswitch() {
        if (vswitch == null) {
            vswitch = new ArrayList<HostVirtualSwitchConfig>();
        }
        return this.vswitch;
    }

    /**
     * Gets the value of the portgroup property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the portgroup property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getPortgroup().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link HostPortGroupConfig }
     * 
     * 
     */
    public List<HostPortGroupConfig> getPortgroup() {
        if (portgroup == null) {
            portgroup = new ArrayList<HostPortGroupConfig>();
        }
        return this.portgroup;
    }

    /**
     * Gets the value of the pnic property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the pnic property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getPnic().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link PhysicalNicConfig }
     * 
     * 
     */
    public List<PhysicalNicConfig> getPnic() {
        if (pnic == null) {
            pnic = new ArrayList<PhysicalNicConfig>();
        }
        return this.pnic;
    }

    /**
     * Gets the value of the vnic property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the vnic property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getVnic().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link HostVirtualNicConfig }
     * 
     * 
     */
    public List<HostVirtualNicConfig> getVnic() {
        if (vnic == null) {
            vnic = new ArrayList<HostVirtualNicConfig>();
        }
        return this.vnic;
    }

    /**
     * Gets the value of the consoleVnic property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the consoleVnic property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getConsoleVnic().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link HostVirtualNicConfig }
     * 
     * 
     */
    public List<HostVirtualNicConfig> getConsoleVnic() {
        if (consoleVnic == null) {
            consoleVnic = new ArrayList<HostVirtualNicConfig>();
        }
        return this.consoleVnic;
    }

    /**
     * Gets the value of the dnsConfig property.
     * 
     * @return
     *     possible object is
     *     {@link HostDnsConfig }
     *     
     */
    public HostDnsConfig getDnsConfig() {
        return dnsConfig;
    }

    /**
     * Sets the value of the dnsConfig property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostDnsConfig }
     *     
     */
    public void setDnsConfig(HostDnsConfig value) {
        this.dnsConfig = value;
    }

    /**
     * Gets the value of the ipRouteConfig property.
     * 
     * @return
     *     possible object is
     *     {@link HostIpRouteConfig }
     *     
     */
    public HostIpRouteConfig getIpRouteConfig() {
        return ipRouteConfig;
    }

    /**
     * Sets the value of the ipRouteConfig property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostIpRouteConfig }
     *     
     */
    public void setIpRouteConfig(HostIpRouteConfig value) {
        this.ipRouteConfig = value;
    }

    /**
     * Gets the value of the consoleIpRouteConfig property.
     * 
     * @return
     *     possible object is
     *     {@link HostIpRouteConfig }
     *     
     */
    public HostIpRouteConfig getConsoleIpRouteConfig() {
        return consoleIpRouteConfig;
    }

    /**
     * Sets the value of the consoleIpRouteConfig property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostIpRouteConfig }
     *     
     */
    public void setConsoleIpRouteConfig(HostIpRouteConfig value) {
        this.consoleIpRouteConfig = value;
    }

    /**
     * Sets the value of the vswitch property.
     * 
     * @param vswitch
     *     allowed object is
     *     {@link HostVirtualSwitchConfig }
     *     
     */
    public void setVswitch(List<HostVirtualSwitchConfig> vswitch) {
        this.vswitch = vswitch;
    }

    /**
     * Sets the value of the portgroup property.
     * 
     * @param portgroup
     *     allowed object is
     *     {@link HostPortGroupConfig }
     *     
     */
    public void setPortgroup(List<HostPortGroupConfig> portgroup) {
        this.portgroup = portgroup;
    }

    /**
     * Sets the value of the pnic property.
     * 
     * @param pnic
     *     allowed object is
     *     {@link PhysicalNicConfig }
     *     
     */
    public void setPnic(List<PhysicalNicConfig> pnic) {
        this.pnic = pnic;
    }

    /**
     * Sets the value of the vnic property.
     * 
     * @param vnic
     *     allowed object is
     *     {@link HostVirtualNicConfig }
     *     
     */
    public void setVnic(List<HostVirtualNicConfig> vnic) {
        this.vnic = vnic;
    }

    /**
     * Sets the value of the consoleVnic property.
     * 
     * @param consoleVnic
     *     allowed object is
     *     {@link HostVirtualNicConfig }
     *     
     */
    public void setConsoleVnic(List<HostVirtualNicConfig> consoleVnic) {
        this.consoleVnic = consoleVnic;
    }

}
